-- name: Mar10 Cakes
-- description: Places A Cake In Most Levels

local Gameload = false

function loaded()
    Gameload = true
end
hook_event(HOOK_ON_MODS_LOADED, loaded)

local E_MODEL_CAKE1 = smlua_model_util_get_id("cakeframe1_geo")
local E_MODEL_CAKE2 = smlua_model_util_get_id("cakeframe2_geo")
local E_MODEL_CAKE3 = smlua_model_util_get_id("cakeframe3_geo")

function bhv_cake_init(obj)
	obj.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	obj.oCollisionDistance = 13000
	obj.header.gfx.skipInViewCheck = true
	obj.collisionData = smlua_collision_util_get("cakecol_collision")
    obj.header.gfx.shadowInvisible = false
    cakedunn = 0
    if cakedunn == 0 then
    cakeframeanim = 1
    cakedunn = 1
    end
end

function bhv_cake_loop(obj)
    cakeframeanim = cakeframeanim + 1
    if cakeframeanim == 13 then
    cakeframeanim = 1
    end
    if cakeframeanim == 4 then
    obj_set_model_extended(obj, E_MODEL_CAKE1)
    elseif cakeframeanim == 8 then
    obj_set_model_extended(obj, E_MODEL_CAKE2)
    elseif cakeframeanim == 12 then
    obj_set_model_extended(obj, E_MODEL_CAKE3)
    end
	load_object_collision_model()
    end

id_bhvCake = hook_behavior(nil, OBJ_LIST_SURFACE, true,
bhv_cake_init, bhv_cake_loop, "bhvcake")

    local function mario_update(m)
        if Gameload == true then
            if (gNetworkPlayers[0].currAreaIndex ~= areadrea) or (gNetworkPlayers[0].currLevelNum ~= outdrea) then
                if gNetworkPlayers[0].currLevelNum == LEVEL_CASTLE_GROUNDS and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -5749, 250, 1933,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 1)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_CASTLE and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, 754, 205, -839,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.35)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_CASTLE and gNetworkPlayers[0].currAreaIndex == 3 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -899, -1279, 2463,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.5)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_SSL and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, 6302, 614, 3055,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 1)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_SSL and gNetworkPlayers[0].currAreaIndex == 2 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, 1433, 1920, 2293,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.5)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_LLL and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, 0, 0, 7420,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 1)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_HMC and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -3600, -4279, 3600,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.25)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_BOB and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -2701, 0, -4481,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.55)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_WF and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -2915, 384, -864,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.55)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_CCM and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, 1060, 3072, -626,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.45)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_CCM and gNetworkPlayers[0].currAreaIndex == 2 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -6162, 6656, -6551,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.75)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_CCM and gNetworkPlayers[0].currAreaIndex == 2 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -7327, -1133, 7252,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 1.5)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_PSS and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, 4084, 6144, -4694,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 1)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_JRB and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, 1026, 1536, 6960,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 1)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_BITDW and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -4657, -900, -2054,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.65)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_DDD and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -2087, -5119, 1553,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.35)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_BITFS and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -7851, -2764, 0,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.25)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_TTM and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -1690, -4430, 5716,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 0.45)
                        end)
                    end
                    if gNetworkPlayers[0].currLevelNum == LEVEL_WDW and gNetworkPlayers[0].currAreaIndex == 1 then
                        spawn_non_sync_object(id_bhvCake, E_MODEL_CAKE1, -1994, 384, 1841,
                        --- @param o Object
                        function(o)
                            obj_scale(o, 1.25)
                        end)
                    end
                end
            end
        areadrea = gNetworkPlayers[0].currAreaIndex
        outdrea = gNetworkPlayers[0].currLevelNum
        end
                
        hook_event(HOOK_MARIO_UPDATE, mario_update)